Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:44 2008
FILE NAME: i.stomate_constants.f90
PROGRAM NAME: stomate_constants
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            !$Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_constants.f90,v 1.17 2007/05/28 14:41:53 ssipsl Exp $
     2:            !IPSL (2006)
     3:            ! This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     4:            !-
     5:            MODULE stomate_constants
     6:            !---------------------------------------------------------------------
     7:              USE defprec
     8:              USE constantes_veg
     9:            !-
    10:            ! Number of pfts
    11:              INTEGER(i_std),PARAMETER :: npft = nvm-1
    12:            !-
    13:            ! bare soil in Sechiba
    14:              INTEGER(i_std),PARAMETER :: ibare_sechiba = 1
    15:            !-
    16:            ! which Sechiba-PFT corresponds to a given Stomate-PFT
    17:              INTEGER(i_std),SAVE,DIMENSION(npft) :: ipft_sechiba
    18:            !-
    19:            ! how many Stomate-PFTs correspond to each Sechiba-PFT ?
    20:            ! e.g. for age classes
    21:              INTEGER(i_std),SAVE,DIMENSION(nvm) :: npft_stomate
    22:            !-
    23:            ! 0 = no, 4 = full online diagnostics
    24:              INTEGER(i_std),SAVE :: bavard=1
    25:            ! write forcing file for carbon spinup?
    26:              LOGICAL,SAVE :: write_carbonforce
    27:            ! Horizontal indices
    28:              INTEGER(i_std),ALLOCATABLE,SAVE,DIMENSION(:) :: hori_index
    29:            ! Horizonatal + PFT indices
    30:              INTEGER(i_std),ALLOCATABLE,SAVE,DIMENSION(:) :: horipft_index
    31:            !-
    32:            ! deforestation
    33:            ! Horizontal + P10 indices
    34:              INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION(:) :: horip10_index
    35:            ! Horizontal + P100 indices
    36:              INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION(:) :: horip100_index 
    37:            ! Horizontal + P11 indices
    38:              INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION(:) :: horip11_index
    39:            ! Horizontal + P101 indices
    40:              INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION(:) :: horip101_index 
    41:            !-
    42:            ! time step
    43:              INTEGER(i_std),SAVE :: itime
    44:            ! STOMATE history file ID
    45:              INTEGER(i_std),SAVE :: hist_id_stomate
    46:            ! STOMATE restart file ID
    47:              INTEGER(i_std),SAVE :: rest_id_stomate
    48:            !-
    49:            ! Freezing point
    50:              REAL(r_std),PARAMETER :: ZeroCelsius = 273.15
    51:            ! e
    52:              REAL(r_std),PARAMETER :: euler = 2.71828182846
    53:            ! Epsilon to detect a near zero floating point
    54:              REAL(r_std),PARAMETER :: min_stomate = 1.E-8_r_std
    55:            ! some large value
    56:              REAL(r_std),PARAMETER :: large_value = 1.E33_r_std
    57:            ! Special value
    58:              REAL(r_std),PARAMETER :: undef = -9999.
    59:            !-
    60:            ! maximum reference long term temperature (K)
    61:              REAL(r_std),PARAMETER :: tlong_ref_max=303.1
    62:            ! minimum reference long term temperature (K)
    63:              REAL(r_std),PARAMETER :: tlong_ref_min=253.1
    64:            !-
    65:            ! trees and litter: indices for the parts of heart- and sapwood above
    66:            !   and below the ground
    67:              INTEGER(i_std),PARAMETER :: iabove = 1
    68:              INTEGER(i_std),PARAMETER :: ibelow = 2
    69:              INTEGER(i_std),PARAMETER :: nlevs = 2
    70:            !-
    71:            ! litter: indices for metabolic and structural part
    72:              INTEGER(i_std),PARAMETER :: imetabolic = 1
    73:              INTEGER(i_std),PARAMETER :: istructural = 2
    74:              INTEGER(i_std),PARAMETER :: nlitt = 2
    75:            !-
    76:            ! carbon pools: indices
    77:              INTEGER(i_std),PARAMETER :: iactive = 1
    78:              INTEGER(i_std),PARAMETER :: islow = 2
    79:              INTEGER(i_std),PARAMETER :: ipassive = 3
    80:              INTEGER(i_std),PARAMETER :: ncarb = 3
    81:            !-
    82:            ! litter fractions: indices
    83:              INTEGER(i_std),PARAMETER :: ileaf = 1
    84:              INTEGER(i_std),PARAMETER :: isapabove = 2
    85:              INTEGER(i_std),PARAMETER :: isapbelow = 3
    86:              INTEGER(i_std),PARAMETER :: iheartabove = 4
    87:              INTEGER(i_std),PARAMETER :: iheartbelow = 5
    88:              INTEGER(i_std),PARAMETER :: iroot = 6
    89:              INTEGER(i_std),PARAMETER :: ifruit = 7
    90:              INTEGER(i_std),PARAMETER :: icarbres = 8
    91:              INTEGER(i_std),PARAMETER :: nparts = 8
    92:            !-
    93:            ! vegetation types: natural and agricultural
    94:              INTEGER(i_std),PARAMETER :: inat = 1
    95:              INTEGER(i_std),PARAMETER :: iagri = 2
    96:              INTEGER(i_std),PARAMETER :: nvegtypes = 2
    97:            !-
    98:            ! transformation between types of surface
    99:              INTEGER(i_std),PARAMETER :: ito_natagri = 1
   100:              INTEGER(i_std),PARAMETER :: ito_total = 2
   101:            !-
   102:            ! leaf age discretisation ( 1 = no discretisation )
   103:              INTEGER(i_std),PARAMETER :: nleafages = 4
   104:            !-
   105:            ! alpha's : ?
   106:              REAL(r_std),PARAMETER :: alpha_grass = .5
   107:              REAL(r_std),PARAMETER :: alpha_tree = 1.
   108:            !-
   109:            ! type declaration for photosynthesis
   110:              TYPE t_photo_type
   111:                REAL(r_std),DIMENSION(npft) :: t_max_a
   112:                REAL(r_std),DIMENSION(npft) :: t_max_b
   113:                REAL(r_std),DIMENSION(npft) :: t_max_c
   114:                REAL(r_std),DIMENSION(npft) :: t_opt_a
   115:                REAL(r_std),DIMENSION(npft) :: t_opt_b
   116:                REAL(r_std),DIMENSION(npft) :: t_opt_c
   117:                REAL(r_std),DIMENSION(npft) :: t_min_a
   118:                REAL(r_std),DIMENSION(npft) :: t_min_b
   119:                REAL(r_std),DIMENSION(npft) :: t_min_c
   120:              END TYPE t_photo_type
   121:            !-
   122:            ! type declaration for phenology
   123:              TYPE pheno_type
   124:                REAL(r_std),DIMENSION(npft,3)     :: gdd
   125:                REAL(r_std),DIMENSION(npft)       :: ngd
   126:                REAL(r_std),DIMENSION(npft)       :: ncdgdd_temp
   127:                REAL(r_std),DIMENSION(npft)       :: hum_frac
   128:                REAL(r_std),DIMENSION(npft)       :: lowgpp_time
   129:                REAL(r_std),DIMENSION(npft)       :: leaffall
   130:                REAL(r_std),DIMENSION(npft)       :: leafagecrit
   131:                REAL(r_std)                       :: tau_hum_month
   132:                REAL(r_std)                       :: tau_hum_week
   133:                REAL(r_std)                       :: tau_t2m_month
   134:                REAL(r_std)                       :: tau_t2m_week
   135:                REAL(r_std)                       :: tau_tsoil_month
   136:                REAL(r_std)                       :: tau_soilhum_month
   137:                REAL(r_std)                       :: tau_gpp_week
   138:                REAL(r_std)                       :: tau_gdd
   139:                REAL(r_std)                       :: tau_ngd
   140:                REAL(r_std)                       :: tau_longterm
   141:                REAL(r_std),DIMENSION(npft)       :: lai_initmin
   142:                CHARACTER(len=6),DIMENSION(npft) :: pheno_model
   143:                CHARACTER(len=6),DIMENSION(npft) :: senescence_type
   144:                REAL(r_std),DIMENSION(npft,3)     :: senescence_temp
   145:                REAL(r_std),DIMENSION(npft)       :: senescence_hum
   146:                REAL(r_std),DIMENSION(npft)       :: nosenescence_hum
   147:                REAL(r_std),DIMENSION(npft)       :: max_turnover_time
   148:                REAL(r_std), DIMENSION(npft)      :: min_leaf_age_for_senescence
   149:                REAL(r_std),DIMENSION(npft)       :: min_turnover_time
   150:            !-
   151:                REAL(r_std),DIMENSION(npft) :: hum_min_time
   152:              END TYPE pheno_type
   153:            !-
   154:            ! parameters for the pipe model
   155:            !-
   156:            ! crown area = pipe_tune1. stem diameter**(1.6) (Reinicke's theory)
   157:              REAL(r_std),PARAMETER :: pipe_tune1 = 100.0
   158:            ! height=pipe_tune2 * diameter**pipe_tune3
   159:              REAL(r_std),PARAMETER :: pipe_tune2 = 40.0
   160:              REAL(r_std),PARAMETER :: pipe_tune3 = 0.5
   161:            ! needed for stem diameter
   162:              REAL(r_std),PARAMETER :: pipe_tune4 = 0.3
   163:            ! Density
   164:              REAL(r_std),PARAMETER :: pipe_density = 2.e5
   165:            ! one more parameter
   166:              REAL(r_std),PARAMETER :: pipe_k1 = 8.e3
   167:            !-
   168:            ! Maximum tree establishment rate
   169:              REAL(r_std),PARAMETER :: estab_max_tree = 0.12
   170:            ! Maximum grass establishment rate
   171:              REAL(r_std),PARAMETER :: estab_max_grass = 0.12
   172:            ! initial density of individuals
   173:              REAL(r_std),PARAMETER :: ind_0 = 0.02
   174:            !-
   175:            ! Do we treat PFT expansion across a grid point after introduction?
   176:            ! default = .FALSE.
   177:              LOGICAL,SAVE :: treat_expansion = .FALSE.
   178:            !-
   179:            ! herbivores?
   180:              LOGICAL,SAVE :: ok_herbivores = .FALSE.
   181:            !-
   182:            ! For trees, minimum fraction of crown area occupied
   183:            ! (due to its branches etc.)
   184:            ! This means that only a small fraction of its crown area
   185:            ! can be invaded by other trees.
   186:              REAL(r_std),PARAMETER :: min_cover = 0.05
   187:            !-
   188:            ! climatic parameters
   189:            !-
   190:            ! minimum precip, in mm/year
   191:              REAL(r_std),PARAMETER :: precip_crit = 100.
   192:            ! minimum gdd for establishment of saplings
   193:              REAL(r_std),PARAMETER :: gdd_crit = 150.
   194:            ! critical fpc, needed for light competition and establishment
   195:              REAL(r_std),PARAMETER :: fpc_crit = 0.95
   196:            !-
   197:            ! critical value for being adapted (1-1/e)
   198:              REAL(r_std),PARAMETER :: adapted_crit = 1. - ( 1. / euler )
   199:            ! critical value for being regenerative (1/e)
   200:              REAL(r_std),PARAMETER :: regenerate_crit = 1. / euler
   201:            !-
   202:            ! fraction of GPP which is lost as growth respiration
   203:              REAL(r_std),PARAMETER :: frac_growthresp = 0.28
   204:            !-
   205:            ! radius of the Earth (m)
   206:              REAL(r_std),PARAMETER :: R_Earth = 6378000.
   207:            !-
   208:            ! description of the PFT
   209:              CHARACTER(len=34),SAVE,DIMENSION(npft) :: PFT_name = &
   210:             & (/ 'tropical  broad-leaved evergreen  ', &
   211:             &    'tropical  broad-leaved raingreen  ', &
   212:             &    'temperate needleleaf   evergreen  ', &
   213:             &    'temperate broad-leaved evergreen  ', &
   214:             &    'temperate broad-leaved summergreen', &
   215:             &    'boreal    needleleaf   evergreen  ', &
   216:             &    'boreal    broad-leaved summergreen', &
   217:             &    'boreal    needleleaf   summergreen', &
   218:             &    '          C3           grass      ', &
   219:             &    '          C4           grass      ', & 
   220:             &    '          C3           agriculture', &
   221:             &    '          C4           agriculture'  /)
   222:            ! extinction coefficient of the Monsi&Seaki (53) relationship
   223:              REAL(r_std),SAVE,DIMENSION(npft) :: ext_coeff
   224:            ! is pft a tree
   225:              LOGICAL,SAVE,DIMENSION(npft) :: tree
   226:            ! leaf type
   227:            ! 1=broad leaved tree, 2=needle leaved tree, 3=grass
   228:              INTEGER(i_std),SAVE,DIMENSION(npft) :: leaf_tab = &
   229:             & (/     1,       1,       2,       1,       1,       2, &
   230:             &        1,       2,       3,       3,       3,       3 /)
   231:            ! natural? 
   232:              LOGICAL,SAVE,DIMENSION(npft) :: natural = &
   233:             & (/ .TRUE.,  .TRUE.,  .TRUE.,  .TRUE.,  .TRUE.,  .TRUE., &
   234:             &    .TRUE.,  .TRUE.,  .TRUE.,  .TRUE., .FALSE., .FALSE. /)
   235:            ! flamability: critical fraction of water holding capacity
   236:              REAL(r_std),SAVE,DIMENSION(npft) :: flam
   237:            ! fire resistance
   238:              REAL(r_std),SAVE,DIMENSION(npft) :: resist = &
   239:             & (/  .12,     .50,     .12,     .50,     .12,     .12,   &
   240:             &     .12,     .12,      .0,      .0,      .0,      .0 /)
   241:            ! specific leaf area (m**2/gC)
   242:              REAL(r_std),SAVE,DIMENSION(npft) :: sla
   243:            ! sapling biomass (gC/ind)
   244:              REAL(r_std),SAVE,DIMENSION(npft,nparts) :: bm_sapl
   245:            ! migration speed (m/year)
   246:              REAL(r_std),SAVE,DIMENSION(npft) :: migrate
   247:            ! maximum stem diameter from which on crown area no longer increases (m)
   248:              REAL(r_std),SAVE,DIMENSION(npft) :: maxdia
   249:            ! critical minimum temperature (K)
   250:              REAL(r_std),SAVE,DIMENSION(npft) :: tmin_crit
   251:            ! critical temperature of the coldest month (K)
   252:              REAL(r_std),SAVE,DIMENSION(npft) :: tcm_crit
   253:            ! critical values for phenology
   254:              TYPE(pheno_type),SAVE :: pheno_crit
   255:            ! time constant for leaf age discretisation (d)
   256:              REAL(r_std),SAVE,DIMENSION(npft) :: leaf_timecst
   257:            ! maximum LAI, PFT-specific
   258:              REAL(r_std),SAVE,DIMENSION (npft) :: lai_max = &
   259:             & (/     7.,     7.,      5.,      5.,      5.,     4.5, &
   260:             &        4.5,    3.0,     2.5,     2.5,     5.,     5.  /)
   261:            ! maintenance respiration coefficient (g/g/day) at 0 deg C
   262:              REAL(r_std),SAVE,DIMENSION(npft,nparts) :: coeff_maint_zero
   263:            ! slope of maintenance respiration coefficient (1/K, 1/K^2, 1/K^3)
   264:              REAL(r_std),SAVE,DIMENSION(npft,3) :: maint_resp_slope
   265:            ! residence time (y) of trees
   266:              REAL(r_std),SAVE,DIMENSION(npft) :: residence_time = &
   267:             & (/    30.0,    30.0,    40.0,    40.0,    40.0,    80.0, &
   268:             &       80.0,    80.0,     0.0,     0.0,     0.0,     0.0 /)
   269:            !SZ modifications
   270:            ! leaf lifetime, tabulated
   271:              REAL(r_std),SAVE,DIMENSION(npft) :: leaflife_tab = &
   272:             & (/        .5,      2.,     .33,      1.,     2.,      .33,   &
   273:             &           2.,      2.,      2.,      2.,     2.,        2. /)
   274:            ! OLD HEAD
   275:            !!$ & (/      .5,      1.,      .5,      .5,      1.,      .5, &
   276:            !!$ &        1.,       1.,      1.,      1.,      1.,     1.  /)
   277:            ! type of phenology
   278:            ! 1=evergreen,  2=summergreen,  3=raingreen,  4=perennial
   279:              INTEGER(i_std),SAVE,DIMENSION(npft) :: pheno_type_tab = &
   280:             & (/      1,        3,       1,       1,       2,       1, &
   281:             &         2,        2,       4,       4,       2,       3 /)
   282:            ! critical tmin, tabulated (C)
   283:              REAL(r_std),SAVE,DIMENSION(npft) :: tmin_crit_tab = &
   284:             & (/     0.0,     0.0,   -45.0,   -10.0,   -45.0,   -60.0, &
   285:             &      -60.0,   undef,   undef,   undef,   undef,   undef /)
   286:            ! critical tcm, tabulated (C)
   287:              REAL(r_std),SAVE,DIMENSION(npft) :: tcm_crit_tab = &
   288:             & (/   undef,   undef,     5.0,    15.5,    15.5,    -2.0, &
   289:             &        5.0,    -2.0,   undef,   undef,   undef,   undef /)
   290:            ! critical gdd, tabulated (C), constant c of aT^2+bT+c
   291:              REAL(r_std),SAVE,DIMENSION(npft) :: gdd_crit1_tab = &
   292:             & (/   undef,   undef,   undef,   undef,   undef,   undef, &
   293:             &      undef,   undef, 184.375,    400.,    125.,    400. /)
   294:            ! critical gdd, tabulated (C), constant b of aT^2+bT+c
   295:              REAL(r_std),SAVE,DIMENSION(npft) :: gdd_crit2_tab = &
   296:             & (/   undef,   undef,   undef,   undef,   undef,   undef, &
   297:             &      undef,   undef,    6.25,      0.,      0.,       0. /)
   298:            ! critical gdd, tabulated (C), constant a of aT^2+bT+c
   299:              REAL(r_std),SAVE,DIMENSION(npft) :: gdd_crit3_tab = &
   300:             & (/   undef,   undef,   undef,   undef,   undef,   undef, &
   301:             &      undef,   undef, 0.03125,      0.,      0.,       0. /)
   302:            ! critical ngd, tabulated. Threshold -5 degrees
   303:              REAL(r_std),SAVE,DIMENSION(npft) :: ngd_crit_tab = &
   304:             & (/   undef,   undef,   undef,   undef,   undef,   undef, &
   305:             &      undef,     17.,   undef,   undef,   undef,   undef /)
   306:            ! critical temperature for the ncd vs. gdd function in phenology
   307:              REAL(r_std),SAVE,DIMENSION(npft) :: ncdgdd_temp_tab = &
   308:             & (/   undef,   undef,   undef,   undef,      5.,   undef, &
   309:             &         0.,   undef,   undef,   undef,   undef,   undef /)
   310:            ! critical humidity (relative to min/max) for phenology
   311:              REAL(r_std),SAVE,DIMENSION(npft) :: hum_frac_tab
   312:            ! minimum duration of dormance (d) for phenology
   313:              REAL(r_std),SAVE,DIMENSION(npft) :: lowgpp_time_tab
   314:            ! minimum time elapsed since moisture minimum (d)
   315:              REAL(r_std),SAVE,DIMENSION(npft) :: hum_min_time_tab
   316:            ! sapwood -> heartwood conversion time (d)
   317:              REAL(r_std),SAVE,DIMENSION(npft) :: tau_sap
   318:            ! fruit lifetime (d)
   319:              REAL(r_std),SAVE,DIMENSION(npft) :: tau_fruit
   320:            ! fraction of primary leaf and root allocation put into reserve
   321:              REAL(r_std),SAVE,DIMENSION(npft) :: ecureuil
   322:            ! Maximum rate of carboxylation
   323:              REAL(r_std),SAVE,DIMENSION(npft) :: vcmax_opt
   324:            ! Maximum rate of RUbp regeneration
   325:              REAL(r_std),SAVE,DIMENSION(npft) :: vjmax_opt
   326:            ! constants needed for photosynthesis temperatures
   327:              TYPE(t_photo_type),SAVE :: t_photo
   328:            ! lenth of death of leaves, tabulated (d)
   329:              REAL(r_std),SAVE,DIMENSION(npft) :: leaffall_tab
   330:            ! critical leaf age, tabulated (d)
   331:              REAL(r_std),SAVE,DIMENSION(npft) :: leafagecrit_tab
   332:            ! which phenology model is used? (tabulated)
   333:              CHARACTER(len=6),SAVE,DIMENSION(npft) :: pheno_model_tab
   334:            ! type of senescence, tabulated
   335:              CHARACTER(len=6),SAVE,DIMENSION(npft) :: senescence_type_tab
   336:            ! critical temperature for senescence (C),
   337:            ! constant c of aT^2+bT+c , tabulated
   338:              REAL(r_std),SAVE,DIMENSION(npft) :: senescence_temp1_tab
   339:            ! critical temperature for senescence (C),
   340:            ! constant b of aT^2+bT+c , tabulated
   341:              REAL(r_std),SAVE,DIMENSION(npft) :: senescence_temp2_tab
   342:            ! critical temperature for senescence (C),
   343:            ! constant a of aT^2+bT+c , tabulated
   344:              REAL(r_std),SAVE,DIMENSION(npft) :: senescence_temp3_tab
   345:            ! critical relative moisture availability for senescence
   346:              REAL(r_std),SAVE,DIMENSION(npft) :: senescence_hum_tab
   347:            ! relative moisture availability above which
   348:            ! there is no humidity-related senescence
   349:              REAL(r_std),SAVE,DIMENSION(npft) :: nosenescence_hum_tab
   350:            ! maximum turnover time for grasse
   351:              REAL(r_std),SAVE,DIMENSION(npft) :: max_turnover_time_tab
   352:            ! minimum turnover time for grasse
   353:              REAL(r_std),SAVE,DIMENSION(npft) :: min_turnover_time_tab
   354:            ! minimum leaf age to allow senescence g
   355:              REAL(r_std), SAVE, DIMENSION(npft)  :: min_leaf_age_for_senescence_tab
   356:            !-
   357:            ! slope of maintenance respiration coefficient (1/K),
   358:            ! constant c of aT^2+bT+c , tabulated
   359:              REAL(r_std),SAVE,DIMENSION(npft) :: maint_resp_slope1_tab
   360:            ! slope of maintenance respiration coefficient (1/K),
   361:            ! constant b of aT^2+bT+c , tabulated
   362:              REAL(r_std),SAVE,DIMENSION(npft) :: maint_resp_slope2_tab
   363:            ! slope of maintenance respiration coefficient (1/K),
   364:            ! constant a of aT^2+bT+c , tabulated
   365:              REAL(r_std),SAVE,DIMENSION(npft) :: maint_resp_slope3_tab
   366:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   367:            ! for leaves, tabulated
   368:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_leaf_tab
   369:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   370:            ! for sapwood above, tabulated
   371:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_sapabove_tab
   372:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   373:            ! for sapwood below, tabulated
   374:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_sapbelow_tab
   375:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   376:            ! for heartwood above, tabulated
   377:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_heartabove_tab
   378:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   379:            ! for heartwood below, tabulated
   380:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_heartbelow_tab
   381:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   382:            ! for roots, tabulated
   383:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_root_tab
   384:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   385:            ! for fruits, tabulated
   386:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_fruit_tab
   387:            ! maintenance respiration coefficient (g/g/day) at 0 deg C,
   388:            ! for carbohydrate reserve, tabulated
   389:              REAL(r_std),SAVE,DIMENSION(npft) :: cm_zero_carbres_tab
   390:            ! minimum photosynthesis temperature,
   391:            ! constant a of ax^2+bx+c (deg C), tabulated
   392:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_min_a_tab
   393:            ! minimum photosynthesis temperature,
   394:            ! constant b of ax^2+bx+c (deg C), tabulated
   395:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_min_b_tab
   396:            ! minimum photosynthesis temperature,
   397:            ! constant c of ax^2+bx+c (deg C), tabulated
   398:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_min_c_tab
   399:            ! optimum photosynthesis temperature,
   400:            ! constant a of ax^2+bx+c (deg C), tabulated
   401:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_opt_a_tab
   402:            ! optimum photosynthesis temperature,
   403:            ! constant b of ax^2+bx+c (deg C), tabulated
   404:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_opt_b_tab
   405:            ! optimum photosynthesis temperature,
   406:            ! constant c of ax^2+bx+c (deg C), tabulated
   407:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_opt_c_tab
   408:            ! maximum photosynthesis temperature,
   409:            ! constant a of ax^2+bx+c (deg C), tabulated
   410:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_max_a_tab
   411:            ! maximum photosynthesis temperature,
   412:            ! constant b of ax^2+bx+c (deg C), tabulated
   413:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_max_b_tab
   414:            ! maximum photosynthesis temperature,
   415:            ! constant c of ax^2+bx+c (deg C), tabulated
   416:              REAL(r_std),SAVE,DIMENSION(npft) :: tphoto_max_c_tab
   417:            !-
   418:            ! tables
   419:            !-
   420:            !-
   421:              DATA flam                   /     .25,     .25,     .25,     .25,     .25,     .25,   &
   422:                                                .25,     .25,     .30,     .30,     .35,     .35 /
   423:            ! DATA flam                   /     .15,     .15,     .15,     .15,     .15,     .15,   &
   424:            !                                   .15,     .15,     .15,     .15,     .15,     .15 /
   425:            !-
   426:              DATA hum_frac_tab           /   undef,      .5,   undef,   undef,   undef,   undef,   &
   427:                                              undef,   undef,      .5,      .5,      .5,      .5 /
   428:            !-
   429:              DATA lowgpp_time_tab        /   undef,     30.,   undef,   undef,     30.,   undef,   &
   430:                                                30.,     30.,     30.,     30.,     30.,     30. /
   431:            !-
   432:              DATA hum_min_time_tab       /   undef,     50.,   undef,   undef,   undef,   undef,   &
   433:                                              undef,   undef,     35.,     35.,     75.,     75. /
   434:            !-
   435:              DATA tau_sap                /    730.,    730.,    730.,    730.,    730.,    730.,   &
   436:                                               730.,    730.,   undef,   undef,   undef,   undef /
   437:            !-
   438:              DATA tau_fruit              /     90.,     90.,     90.,     90.,     90.,     90.,   &
   439:                                                90.,     90.,   undef,   undef,   undef,   undef /
   440:            !-
   441:              DATA ecureuil               /      .0,      1.,      .0,      .0,      1.,      .0,   &
   442:                                                 1.,      1.,      1.,      1.,      1.,      1. /
   443:            !-
   444:            ! Shilong modification
   445:              DATA vcmax_opt              /     65.,     65.,     35.,     40.,     55.,     35.,   &
   446:                                                45.,     35.,     70.,     70.,     70.,     70. /
   447:            ! OLD HEAD
   448:            !!$                              /     65.,     65.,     35.,     40.,     55.,     35.,   &
   449:            !!$                                    45.,     35.,     80.,     80.,    100.,    100. /
   450:            !modif jerome carbofor
   451:            !  DATA vcmax_opt              /     65.,     65.,     50.,     40.,     75.,     35.,   &
   452:            !                                    45.,     35.,     80.,     80.,    100.,    100. /
   453:            
   454:              DATA vjmax_opt              /    130.,    130.,     70.,     80.,    110.,     70.,   &
   455:                                                90.,     70.,    160.,    160.,    200.,    200. /
   456:            !-
   457:            !DATA vcmax_opt_tab          /     65.,     65.,    37.5,     45.,     60.,    37.5,   &
   458:            !                                  50.,     40.,    100.,    100.,    100.,    100. /
   459:             
   460:            !DATA vjmax_opt_tab          /    130.,    130.,     75.,     90.,    120.,     75.,   &
   461:            !                                 100.,     80.,    200.,    200.,    200.,    200. /
   462:            !-
   463:              DATA leaffall_tab           /   undef,     10.,   undef,   undef,     10.,   undef,   &
   464:                                                10.,     10.,     10.,     10.,     10.,     10. /
   465:            !-
   466:            ! Shilong modification
   467:              DATA leafagecrit_tab        /    730.,    180.,    910.,    730.,    180.,    910.,   &
   468:                                               180.,    180.,    120.,    120.,    90.,     90. /
   469:            ! OLD HEAD
   470:            !!$  DATA leafagecrit_tab        /    730.,    180.,    910.,    730.,    180.,    910.,   &
   471:            !!$                                   180.,    180.,    120.,    120.,    120.,    120. /
   472:            !-
   473:              DATA ipft_sechiba           /       2,       3,       4,       5,       6,       7,   &
   474:                                                  8,       9,      10,      11,      12,      13 /
   475:            !-
   476:              DATA senescence_type_tab    /  'none',   'dry',  'none',  'none',  'cold',  'none',   &
   477:                                             'cold',  'cold', 'mixed', 'mixed', 'mixed', 'mixed' /
   478:            !-
   479:              DATA senescence_temp1_tab   /   undef,   undef,   undef,   undef,     12.,   undef,   &
   480:                                                 7.,      2.,  -1.375,      5.,      5.,     10. /
   481:              DATA senescence_temp2_tab   /   undef,   undef,   undef,   undef,      0.,   undef,   &
   482:                                                 0.,      0.,      .1,      0.,      0.,      0. /
   483:              DATA senescence_temp3_tab   /   undef,   undef,   undef,   undef,      0.,   undef,   &
   484:                                                 0.,      0.,  .00375,      0.,      0.,      0. /
   485:            !-
   486:              DATA senescence_hum_tab     /   undef,      .6,   undef,   undef,   undef,   undef,   &
   487:                                              undef,   undef,      .2,      .2,      .3,      .2 /
   488:            !-
   489:              DATA nosenescence_hum_tab   /   undef,      1.,   undef,   undef,   undef,   undef,   &
   490:                                              undef,   undef,      .3,      .3,      .3,      .3 /
   491:            !-
   492:              DATA max_turnover_time_tab   /   undef,  undef,   undef,   undef,   undef,   undef,   &
   493:                                              undef,   undef,      80.,  80.,    80.,    80. /
   494:            !-
   495:              DATA min_turnover_time_tab   /   undef,  undef,   undef,   undef,   undef,   undef,   &
   496:                                              undef,   undef,      10.,      10.,      10.,      10. /
   497:            !-
   498:              DATA min_leaf_age_for_senescence_tab   /   undef,  90,   undef,   undef,   90,   undef,   &
   499:                                              60,   60,      30.,      30.,      30.,      30. /
   500:            !-
   501:              DATA pheno_model_tab        /  'none',   'moi',  'none',  'none','ncdgdd',  'none',   &
   502:                                           'ncdgdd',   'ngd','moigdd','moigdd','moigdd','moigdd' /
   503:            !-
   504:            ! DATA maint_resp_slope1_tab  /     .16,     .16,     .16,     .16,     .16,     .16,   &
   505:            !                                   .16,     .16,     .16,     .16,     .16,     .16 /
   506:            ! DATA maint_resp_slope2_tab  /      .0,      .0,      .0,      .0,      .0,      .0,   &
   507:            !                                    .0,      .0,      .0,      .0,      .0,      .0 /
   508:              DATA maint_resp_slope1_tab  /     .12,     .12,     .16,     .16,     .16,     .16,   &
   509:                                                .16,     .16,     .16,     .12,     .16,     .12 /
   510:              DATA maint_resp_slope2_tab  /      .0,      .0,      .0,      .0,      .0,      .0,   &
   511:                                                 .0,      .0, -.00133,      .0, -.00133,      .0 /
   512:              DATA maint_resp_slope3_tab  /      .0,      .0,      .0,      .0,      .0,      .0,   &
   513:                                                 .0,      .0,      .0,      .0,      .0,      .0 /
   514:            !-
   515:              DATA cm_zero_leaf_tab       / 2.35E-3, 2.62E-3, 1.01E-3, 2.35E-3, 2.62E-3, 1.01E-3,   &
   516:                                            2.62E-3, 2.05E-3, 2.62E-3, 2.62E-3, 2.62E-3, 2.62E-3 /
   517:            !-
   518:              DATA cm_zero_sapabove_tab   / 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4,   &
   519:                                            1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4 /
   520:            !-
   521:              DATA cm_zero_sapbelow_tab   / 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4,   &
   522:                                            1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4 /
   523:            !-
   524:              DATA cm_zero_heartabove_tab /      0.,      0.,      0.,      0.,      0.,      0.,   &
   525:                                                 0.,      0.,      0.,      0.,      0.,      0. /
   526:            !-
   527:              DATA cm_zero_heartbelow_tab /      0.,      0.,      0.,      0.,      0.,      0.,   &
   528:                                                 0.,      0.,      0.,      0.,      0.,      0. /
   529:            !-
   530:              DATA cm_zero_root_tab       / 1.67E-3, 1.67E-3, 1.67E-3, 1.67E-3, 1.67E-3, 1.67E-3,   &
   531:                                            1.67E-3, 1.67E-3, 1.67E-3, 1.67E-3, 1.67E-3, 1.67E-3 /
   532:            !-
   533:              DATA cm_zero_fruit_tab      / 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4,   &
   534:                                            1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4 /
   535:            !-
   536:              DATA cm_zero_carbres_tab    / 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4,   &
   537:                                            1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4, 1.19E-4 /
   538:            !-
   539:              DATA tphoto_min_c_tab       /      2.,      2.,     -4.,     -3.,     -2.,     -4.,   &
   540:                                                -4.,     -4.,   -3.25,     13.,     -5.,     13. /
   541:              DATA tphoto_min_b_tab       /      0.,      0.,      0.,      0.,      0.,      0.,   &
   542:                                                 0.,      0.,     0.1,      0.,      0.,      0. /
   543:              DATA tphoto_min_a_tab       /      0.,      0.,      0.,      0.,      0.,      0.,   &
   544:                                                 0.,      0.,  0.0025,      0.,      0.,      0. /
   545:              DATA tphoto_opt_c_tab       /     37.,     37.,     25.,     32.,     26.,     25.,   &
   546:                                                25.,     25.,   27.25,     36.,     30.,     36. /
   547:              DATA tphoto_opt_b_tab       /      0.,      0.,      0.,      0.,      0.,      0.,   &
   548:                                                 0.,      0.,    0.25,      0.,      0.,      0. /
   549:              DATA tphoto_opt_a_tab       /      0.,      0.,      0.,      0.,      0.,      0.,   &
   550:                                                 0.,      0.,  0.0025,      0.,      0.,      0. /
   551:              DATA tphoto_max_c_tab       /     55.,     55.,     38.,     48.,     38.,     38.,   &
   552:                                                38.,     38.,  41.125,     55.,     45.,     55. /
   553:              DATA tphoto_max_b_tab       /      0.,      0.,      0.,      0.,      0.,      0.,   &
   554:                                                 0.,      0.,    0.35,      0.,      0.,      0. /
   555:              DATA tphoto_max_a_tab       /      0.,      0.,      0.,      0.,      0.,      0.,   &
   556:                                                 0.,      0., 0.00375,      0.,      0.,      0. /
   557:            !---------------------------
   558:            END MODULE stomate_constants
