Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:44 2008
FILE NAME: i.stomate_resp.f90
PROGRAM NAME: stomate_resp
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    98  vec  (   4): Vectorized array expression.
   117  vec  (   4): Vectorized array expression.
   123  vec  (   3): Unvectorized loop.
   123  vec  (  13): Overhead of loop division is too large.
   125  vec  (   4): Vectorized array expression.
   140  vec  (   4): Vectorized array expression.
   157  vec  (   4): Vectorized array expression.
   159  vec  (   4): Vectorized array expression.
   166  opt  (1082): Backward transfers inhibit loop optimization.
   166  vec  (   4): Vectorized array expression.
   170  vec  (   3): Unvectorized loop.
   172  opt  (1592): Outer loop unrolled inside inner loop.
   172  vec  (   4): Vectorized array expression.
   190  vec  (   4): Vectorized array expression.
   196  vec  (   4): Vectorized array expression.
   203  vec  (   3): Unvectorized loop.
   203  vec  (  13): Overhead of loop division is too large.
   208  vec  (   4): Vectorized array expression.
   217  vec  (   4): Vectorized array expression.
   234  warn (  82): Name "t_maint" is not used.
   234  warn (  82): Name "i" is not used.
   234  warn (  82): Name "m" is not used.
   234  warn (  83): Dummy argument "height" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:44 2008
FILE NAME: i.stomate_resp.f90
PROGRAM NAME: stomate_resp
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            !$Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_resp.f90,v 1.6 2007/05/28 14:57:23 ssipsl Exp $
     2:            !IPSL (2006)
     3:            ! This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     4:             
     5:              !  calculate maintenance respiration on an hourly time step (NV 14/5/2002)
     6:            MODULE stomate_resp
     7:              ! modules used:
     8:              USE stomate_constants
     9:            
    10:              IMPLICIT NONE
    11:            
    12:              ! private & public routines
    13:            
    14:              PRIVATE
    15:              PUBLIC maint_respiration,maint_respiration_clear
    16:            
    17:                ! first call
    18:                LOGICAL, SAVE                                              :: firstcall = .TRUE.
    19:            
    20:            CONTAINS
    21:            
    22:              SUBROUTINE maint_respiration_clear
    23:                firstcall=.TRUE.
    24:              END SUBROUTINE maint_respiration_clear
    25:            
    26:             SUBROUTINE maint_respiration ( npts,dt,t2m,tlong_ref,stempdiag,height,veget_max,space_nat,&
    27:                                      rprof,biomass,resp_maint_part_radia)
    28:            
    29:                !
    30:                ! 0 declarations
    31:                !
    32:            
    33:                ! 0.1 input
    34:            
    35:                ! Domain size
    36:                INTEGER(i_std), INTENT(in)                                        :: npts
    37:                ! time step (seconds)
    38:                REAL(r_std), INTENT(in)                                     :: dt
    39:                 ! 2 m air temperature (K)
    40:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m
    41:                 ! 2 m air temperature (K)
    42:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: tlong_ref
    43:                 ! natural space
    44:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: space_nat
    45:                ! Soil temperature
    46:                REAL(r_std),DIMENSION (npts,nbdl), INTENT (in)              :: stempdiag
    47:               ! height of vegetation (m)
    48:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: height
    49:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    50:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: veget_max
    51:                ! root depth (m)
    52:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: rprof
    53:                ! biomass (gC/m**2)
    54:                REAL(r_std),DIMENSION(npts,npft,nparts),INTENT(in)          :: biomass 
    55:                ! 0.2 modified fields
    56:            
    57:            
    58:                ! 0.3 output
    59:            
    60:                ! maintenance respiration of different parts (gC/dt/m**2 of total ground)
    61:               REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(out)             :: resp_maint_part_radia
    62:                 ! 0.4 local
    63:            
    64:                ! leaf area index
    65:                REAL(r_std), DIMENSION(npts,npft)                           :: lai
    66:                ! soil levels (m)
    67:                REAL(r_std), SAVE, DIMENSION(0:nbdl)                        :: z_soil
    68:                ! root temperature (convolution of root and soil temperature profiles)
    69:                REAL(r_std), DIMENSION(npts,npft)                           :: t_root
    70:                ! maintenance respiration coefficients at 0 deg C (g/g d**-1)
    71:                REAL(r_std), DIMENSION(npts,npft,nparts)                    :: coeff_maint
    72:                ! temperature which is pertinent for maintenance respiration (K)
    73:                REAL(r_std), DIMENSION(npts,nparts)                         :: t_maint
    74:                ! integration constant for root profile
    75:                REAL(r_std), DIMENSION(npts)                                :: rpc
    76:               ! temperature which is pertinent for maintenance respiration (K)
    77:                REAL(r_std), DIMENSION(npts,nparts)                         :: t_maint_radia
    78:                ! long term annual mean temperature, C
    79:                REAL(r_std), DIMENSION(npts)                                :: tl
    80:                ! slope of maintenance respiration coefficient (1/K)
    81:                REAL(r_std), DIMENSION(npts)                                :: slope
    82:               ! Index
    83:                INTEGER(i_std)                                              :: i,j,k,l,m
    84:             
    85:                !
    86:                !
    87:                ! 2 define maintenance respiration coefficients
    88:                !
    89:                IF (bavard.GE.3) WRITE(numout,*) 'Entering respiration'
    90:                !
    91:                ! 1 Initializations
    92:                !
    93:                 IF ( firstcall ) THEN
    94:            
    95:                  ! 1.1.1 soil levels
    96:            
    97:                  z_soil(0) = 0.
    98: V======          z_soil(1:nbdl) = diaglev(1:nbdl)
    99:            
   100:                  ! 1.1.2 messages
   101:            
   102:                  WRITE(numout,*) 'respiration:'
   103:            
   104:                  firstcall = .FALSE.
   105:            
   106:                ENDIF
   107:            
   108:                !
   109:                 
   110:                !
   111:               ! 1 do initialisation
   112:                !
   113:            
   114: +------>          DO j = 1, npft
   115: |                    
   116: |                    ! 1.3.1 rpc is an integration constant such that the integral of the root profile is 1.
   117: |V----->             rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / rprof(:,j) ) )
   118: ||                   
   119: ||                   ! 1.3.2 integrate over the nbdl levels
   120: ||                   
   121: |V-----              t_root(:,j) = 0.0
   122: |                    
   123: |+----->             DO l = 1, nbdl
   124: ||                      
   125: ||V====                 t_root(:,j) = &
   126: ||                           t_root(:,j) + stempdiag(:,l) * rpc(:) * &
   127: ||                           ( EXP( -z_soil(l-1)/rprof(:,j) ) - EXP( -z_soil(l)/rprof(:,j) ) )
   128: ||                      
   129: |+-----              ENDDO
   130: |                    
   131: +------           ENDDO
   132: +------>          DO j = 1, npft
   133: |                    
   134: |                    !
   135: |                    ! 2.1 temperature which is taken for the plant part we are talking about
   136: |                    !
   137: |                    
   138: |                    ! 2.1.1 parts above the ground
   139: |                    
   140: |V----->             t_maint_radia(:,ileaf) = t2m(:)
   141: ||                   t_maint_radia(:,isapabove) = t2m(:)
   142: ||                   t_maint_radia(:,ifruit) = t2m(:)
   143: ||                   
   144: ||                   ! 2.1.2 parts below the ground
   145: ||                   
   146: ||                   t_maint_radia(:,isapbelow) = t_root(:,j)
   147: ||                   t_maint_radia(:,iroot) = t_root(:,j)
   148: ||                   
   149: ||                   ! 2.1.3 heartwood: does not respire. Any temperature
   150: ||                   
   151: ||                   t_maint_radia(:,iheartbelow) = t_root(:,j)
   152: |V-----              t_maint_radia(:,iheartabove) = t2m(:)
   153: |                    
   154: |                    ! 2.1.4 reserve: above the ground for trees, below for grasses
   155: |                    
   156: |                    IF ( tree(j) ) THEN
   157: |V=====                 t_maint_radia(:,icarbres) = t2m(:)
   158: |                    ELSE
   159: |V=====                 t_maint_radia(:,icarbres) = t_root(:,j)
   160: |                    ENDIF
   161: |                    
   162: |                    !
   163: |                ! 2.2 calculate coefficient
   164: |                    !
   165: |                    
   166: |V----->             tl(:) = tlong_ref(:) - ZeroCelsius
   167: |V-----              slope(:) = maint_resp_slope(j,1) + tl(:) * maint_resp_slope(j,2) + &
   168: |                         tl(:)*tl(:) * maint_resp_slope(j,3)
   169: |                    
   170: |+----->             DO k = 1, nparts
   171: ||                      
   172: ||V====                 coeff_maint(:,j,k) = &
   173: ||                           MAX( (coeff_maint_zero(j,k)*dt/one_day) * &
   174: ||                           ( 1. + slope(:) * (t_maint_radia(:,k)-ZeroCelsius) ), 0._r_std )
   175: ||                      
   176: |+-----              ENDDO
   177: |                    
   178: +------           ENDDO
   179:                   
   180:                   !
   181:                   ! 3 calculate maintenance respiration.
   182:                   !
   183:                   
   184: +------>          DO j = 1, npft
   185: |                    
   186: |                    !
   187: |                    ! 3.1 maintenance respiration of the different plant parts
   188: |                    !
   189: |                    IF (natural(j)) THEN 
   190: |V----->                WHERE ( veget_max(:,j) .GT. 0.0 )
   191: ||                         lai(:,j) = biomass(:,j,ileaf)*space_nat  / veget_max(:,j) * sla(j)
   192: ||                      ELSEWHERE
   193: |V-----                    lai(:,j) = 0.0
   194: |                       ENDWHERE
   195: |                    ELSE
   196: |V----->                WHERE ( veget_max(:,j) .GT. 0.0 )
   197: ||                         lai(:,j) = biomass(:,j,ileaf)*(1-space_nat)  / veget_max(:,j) * sla(j)
   198: ||                      ELSEWHERE
   199: |V-----                    lai(:,j) = 0.0
   200: |                       ENDWHERE
   201: |                    ENDIF
   202: |          
   203: |+----->             DO k = 1, nparts
   204: ||                      
   205: ||                      IF ( k .EQ. ileaf ) THEN
   206: ||                         
   207: ||                         ! Leaves: respiration depends on leaf mass AND LAI.
   208: ||V---->                   WHERE ( (biomass(:,j,ileaf) .GT. min_stomate) .AND. (lai(:,j) .GT. 0.0) )
   209: |||                           resp_maint_part_radia(:,j,k) = coeff_maint(:,j,k) * biomass(:,j,k) * &
   210: |||                                ( .3*lai(:,j) + 1.4*(1.-exp(-.5*lai(:,j))) ) / lai(:,j)
   211: |||                        ELSEWHERE
   212: ||V----                       resp_maint_part_radia(:,j,k) = 0.0
   213: ||                         ENDWHERE
   214: ||                         
   215: ||                      ELSE
   216: ||                         
   217: ||V====                    resp_maint_part_radia(:,j,k) = coeff_maint(:,j,k) * biomass(:,j,k)
   218: ||                         
   219: ||                      ENDIF
   220: ||                      
   221: |+-----              ENDDO
   222: |          
   223: |                    !
   224: |                    ! 3.2 Total maintenance respiration of the plant
   225: |                    !     VPP killer:
   226: |                    !     resp_maint(:,j) = SUM( resp_maint_part(:,:), DIM=2 )
   227: |                    !
   228: |                    
   229: +------           ENDDO
   230:            
   231:            
   232:              IF (bavard.GE.4) WRITE(numout,*) 'Leaving respiration'
   233:            
   234:              END SUBROUTINE maint_respiration
   235:            
   236:            END MODULE stomate_resp
